/// @cond EO_CXX_EO_IMPL

inline ::evas_3d_node::_c_constructor evas_3d_node::constructor(Evas_3D_Node_Type type_)
{
   return _c_constructor(type_);
}

inline Evas_3D_Node_Type evas_3d_node::type_get() const
{
   Evas_3D_Node_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_type_get());
   return _tmp_ret;
}

inline void evas_3d_node::member_add(Evas_3D_Node * member_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_member_add(member_));
}

inline void evas_3d_node::member_del(Evas_3D_Node * member_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_member_del(member_));
}

inline Evas_3D_Node * evas_3d_node::parent_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_parent_get());
   return _tmp_ret;
}

inline ::efl::eina::crange_list< Evas_3D_Node * > evas_3d_node::member_list_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_member_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void evas_3d_node::position_set(Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_set(x_, y_, z_));
}

inline void evas_3d_node::orientation_set(Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_Real w_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_set(x_, y_, z_, w_));
}

inline void evas_3d_node::orientation_angle_axis_set(Evas_Real angle_, Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_angle_axis_set(angle_, x_, y_, z_));
}

inline void evas_3d_node::scale_set(Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_set(x_, y_, z_));
}

inline void evas_3d_node::position_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_get(space_, x_, y_, z_));
}

inline void evas_3d_node::orientation_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_, Evas_Real* w_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_get(space_, x_, y_, z_, w_));
}

inline void evas_3d_node::scale_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_get(space_, x_, y_, z_));
}

inline void evas_3d_node::look_at_set(Evas_3D_Space target_space_, Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_3D_Space up_space_, Evas_Real ux_, Evas_Real uy_, Evas_Real uz_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_look_at_set(target_space_, x_, y_, z_, up_space_, ux_, uy_, uz_));
}

inline void evas_3d_node::mesh_add(Evas_3D_Mesh * mesh_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_add(mesh_));
}

inline void evas_3d_node::mesh_del(Evas_3D_Mesh * mesh_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_del(mesh_));
}

inline ::efl::eina::crange_list< Evas_3D_Mesh * > evas_3d_node::mesh_list_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_mesh_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Mesh * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void evas_3d_node::bounding_box_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * x2_, Evas_Real * y2_, Evas_Real * z2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_bounding_box_get(x_, y_, z_, x2_, y2_, z2_));
}

inline void evas_3d_node::bounding_sphere_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * r_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_bounding_sphere_get(x_, y_, z_, r_));
}

inline bool evas_3d_node::position_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_position_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_node::position_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline bool evas_3d_node::orientation_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_orientation_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_node::orientation_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline bool evas_3d_node::scale_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_scale_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_node::scale_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline Evas_3D_Camera * evas_3d_node::camera_get() const
{
   Evas_3D_Camera * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_camera_get());
   return _tmp_ret;
}

inline void evas_3d_node::camera_set(Evas_3D_Camera * camera_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_camera_set(camera_));
}

inline Evas_3D_Light * evas_3d_node::light_get() const
{
   Evas_3D_Light * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_light_get());
   return _tmp_ret;
}

inline void evas_3d_node::light_set(Evas_3D_Light * light_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_light_set(light_));
}

inline int evas_3d_node::mesh_frame_get(Evas_3D_Mesh * mesh_) const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_mesh_frame_get(mesh_));
   return _tmp_ret;
}

inline void evas_3d_node::mesh_frame_set(Evas_3D_Mesh * mesh_, int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_frame_set(mesh_, frame_));
}

inline ::efl::eo::concrete evas_3d_node::billboard_target_get() const
{
   Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_billboard_target_get());
   return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_node::billboard_target_set(::efl::eo::concrete target_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_billboard_target_set(::efl::eolian::to_c(target_)));
}

inline Evas_3D_Node_Type eo_cxx::evas_3d_node::type_get() const
{
   Evas_3D_Node_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_type_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_node::member_add(Evas_3D_Node * member_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_member_add(member_));
}

inline void eo_cxx::evas_3d_node::member_del(Evas_3D_Node * member_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_member_del(member_));
}

inline Evas_3D_Node * eo_cxx::evas_3d_node::parent_get() const
{
   Evas_3D_Node * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_parent_get());
   return _tmp_ret;
}

inline ::efl::eina::crange_list< Evas_3D_Node * > eo_cxx::evas_3d_node::member_list_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_member_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void eo_cxx::evas_3d_node::position_set(Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_set(x_, y_, z_));
}

inline void eo_cxx::evas_3d_node::orientation_set(Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_Real w_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_set(x_, y_, z_, w_));
}

inline void eo_cxx::evas_3d_node::orientation_angle_axis_set(Evas_Real angle_, Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_angle_axis_set(angle_, x_, y_, z_));
}

inline void eo_cxx::evas_3d_node::scale_set(Evas_Real x_, Evas_Real y_, Evas_Real z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_set(x_, y_, z_));
}

inline void eo_cxx::evas_3d_node::position_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_get(space_, x_, y_, z_));
}

inline void eo_cxx::evas_3d_node::orientation_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_, Evas_Real* w_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_get(space_, x_, y_, z_, w_));
}

inline void eo_cxx::evas_3d_node::scale_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_get(space_, x_, y_, z_));
}

inline void eo_cxx::evas_3d_node::look_at_set(Evas_3D_Space target_space_, Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_3D_Space up_space_, Evas_Real ux_, Evas_Real uy_, Evas_Real uz_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_look_at_set(target_space_, x_, y_, z_, up_space_, ux_, uy_, uz_));
}

inline void eo_cxx::evas_3d_node::mesh_add(Evas_3D_Mesh * mesh_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_add(mesh_));
}

inline void eo_cxx::evas_3d_node::mesh_del(Evas_3D_Mesh * mesh_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_del(mesh_));
}

inline ::efl::eina::crange_list< Evas_3D_Mesh * > eo_cxx::evas_3d_node::mesh_list_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_mesh_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Mesh * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void eo_cxx::evas_3d_node::bounding_box_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * x2_, Evas_Real * y2_, Evas_Real * z2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_bounding_box_get(x_, y_, z_, x2_, y2_, z2_));
}

inline void eo_cxx::evas_3d_node::bounding_sphere_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * r_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_bounding_sphere_get(x_, y_, z_, r_));
}

inline bool eo_cxx::evas_3d_node::position_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_position_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_node::position_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_position_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline bool eo_cxx::evas_3d_node::orientation_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_orientation_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_node::orientation_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_orientation_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline bool eo_cxx::evas_3d_node::scale_inherit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_scale_inherit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_node::scale_inherit_set(bool inherit_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_scale_inherit_set(::efl::eolian::to_c(inherit_)));
}

inline Evas_3D_Camera * eo_cxx::evas_3d_node::camera_get() const
{
   Evas_3D_Camera * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_camera_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_node::camera_set(Evas_3D_Camera * camera_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_camera_set(camera_));
}

inline Evas_3D_Light * eo_cxx::evas_3d_node::light_get() const
{
   Evas_3D_Light * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_light_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_node::light_set(Evas_3D_Light * light_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_light_set(light_));
}

inline int eo_cxx::evas_3d_node::mesh_frame_get(Evas_3D_Mesh * mesh_) const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_mesh_frame_get(mesh_));
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_node::mesh_frame_set(Evas_3D_Mesh * mesh_, int frame_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_mesh_frame_set(mesh_, frame_));
}

inline ::efl::eo::concrete eo_cxx::evas_3d_node::billboard_target_get() const
{
   Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_node_billboard_target_get());
   return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_node::billboard_target_set(::efl::eo::concrete target_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_node_billboard_target_set(::efl::eolian::to_c(target_)));
}

inline ::eo_cxx::evas_3d_node::operator ::evas_3d_node() const
{
   return *static_cast<::evas_3d_node const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_node::operator ::evas_3d_node&()
{
   return *static_cast<::evas_3d_node*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_node::operator ::evas_3d_node const&() const
{
   return *static_cast<::evas_3d_node const*>(static_cast<void const*>(this));
}

template <typename T>
Evas_3D_Node_Type _evas_3d_node_type_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Node_Type _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->type_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_member_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * member_)
{
   try
      {
         static_cast<T*>(self->this_)->member_add(member_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_member_del_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * member_)
{
   try
      {
         static_cast<T*>(self->this_)->member_del(member_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Node * _evas_3d_node_parent_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Node * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->parent_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
::efl::eina::crange_list< Evas_3D_Node * > _evas_3d_node_member_list_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eina::crange_list< Evas_3D_Node * > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->member_list_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_position_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_Real z_)
{
   try
      {
         static_cast<T*>(self->this_)->position_set(x_, y_, z_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_orientation_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_Real w_)
{
   try
      {
         static_cast<T*>(self->this_)->orientation_set(x_, y_, z_, w_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_orientation_angle_axis_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real angle_, Evas_Real x_, Evas_Real y_, Evas_Real z_)
{
   try
      {
         static_cast<T*>(self->this_)->orientation_angle_axis_set(angle_, x_, y_, z_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_scale_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_Real z_)
{
   try
      {
         static_cast<T*>(self->this_)->scale_set(x_, y_, z_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_position_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_)
{
   try
      {
         static_cast<T*>(self->this_)->position_get(space_, x_, y_, z_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_orientation_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_, Evas_Real* w_)
{
   try
      {
         static_cast<T*>(self->this_)->orientation_get(space_, x_, y_, z_, w_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_scale_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_)
{
   try
      {
         static_cast<T*>(self->this_)->scale_get(space_, x_, y_, z_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_look_at_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Space target_space_, Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_3D_Space up_space_, Evas_Real ux_, Evas_Real uy_, Evas_Real uz_)
{
   try
      {
         static_cast<T*>(self->this_)->look_at_set(target_space_, x_, y_, z_, up_space_, ux_, uy_, uz_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_mesh_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh * mesh_)
{
   try
      {
         static_cast<T*>(self->this_)->mesh_add(mesh_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_mesh_del_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh * mesh_)
{
   try
      {
         static_cast<T*>(self->this_)->mesh_del(mesh_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< Evas_3D_Mesh * > _evas_3d_node_mesh_list_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eina::crange_list< Evas_3D_Mesh * > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->mesh_list_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_bounding_box_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * x2_, Evas_Real * y2_, Evas_Real * z2_)
{
   try
      {
         static_cast<T*>(self->this_)->bounding_box_get(x_, y_, z_, x2_, y2_, z2_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_node_bounding_sphere_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * r_)
{
   try
      {
         static_cast<T*>(self->this_)->bounding_sphere_get(x_, y_, z_, r_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_node_position_inherit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->position_inherit_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_position_inherit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool inherit_)
{
   try
      {
         static_cast<T*>(self->this_)->position_inherit_set(::efl::eolian::to_cxx<bool>(inherit_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_node_orientation_inherit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->orientation_inherit_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_orientation_inherit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool inherit_)
{
   try
      {
         static_cast<T*>(self->this_)->orientation_inherit_set(::efl::eolian::to_cxx<bool>(inherit_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_node_scale_inherit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->scale_inherit_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_scale_inherit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool inherit_)
{
   try
      {
         static_cast<T*>(self->this_)->scale_inherit_set(::efl::eolian::to_cxx<bool>(inherit_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Camera * _evas_3d_node_camera_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Camera * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->camera_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_camera_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Camera * camera_)
{
   try
      {
         static_cast<T*>(self->this_)->camera_set(camera_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Light * _evas_3d_node_light_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Light * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->light_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_light_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Light * light_)
{
   try
      {
         static_cast<T*>(self->this_)->light_set(light_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int _evas_3d_node_mesh_frame_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh * mesh_)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->mesh_frame_get(mesh_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_mesh_frame_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Mesh * mesh_, int frame_)
{
   try
      {
         static_cast<T*>(self->this_)->mesh_frame_set(mesh_, frame_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eo::concrete _evas_3d_node_billboard_target_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eo::concrete _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->billboard_target_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_node_billboard_target_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eo * target_)
{
   try
      {
         static_cast<T*>(self->this_)->billboard_target_set(::efl::eolian::to_cxx<::efl::eo::concrete>(target_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_node >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual Evas_3D_Node_Type type_get()
      {
         Evas_3D_Node_Type _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_type_get());
            return _tmp_ret;
      }

      virtual void member_add(Evas_3D_Node * member_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_member_add(member_));
      }

      virtual void member_del(Evas_3D_Node * member_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_member_del(member_));
      }

      virtual Evas_3D_Node * parent_get()
      {
         Evas_3D_Node * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_parent_get());
            return _tmp_ret;
      }

      virtual ::efl::eina::crange_list< Evas_3D_Node * > member_list_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_member_list_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual void position_set(Evas_Real x_, Evas_Real y_, Evas_Real z_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_position_set(x_, y_, z_));
      }

      virtual void orientation_set(Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_Real w_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_orientation_set(x_, y_, z_, w_));
      }

      virtual void orientation_angle_axis_set(Evas_Real angle_, Evas_Real x_, Evas_Real y_, Evas_Real z_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_orientation_angle_axis_set(angle_, x_, y_, z_));
      }

      virtual void scale_set(Evas_Real x_, Evas_Real y_, Evas_Real z_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_scale_set(x_, y_, z_));
      }

      virtual void position_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_position_get(space_, x_, y_, z_));
      }

      virtual void orientation_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_, Evas_Real* w_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_orientation_get(space_, x_, y_, z_, w_));
      }

      virtual void scale_get(Evas_3D_Space space_, Evas_Real* x_, Evas_Real* y_, Evas_Real* z_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_scale_get(space_, x_, y_, z_));
      }

      virtual void look_at_set(Evas_3D_Space target_space_, Evas_Real x_, Evas_Real y_, Evas_Real z_, Evas_3D_Space up_space_, Evas_Real ux_, Evas_Real uy_, Evas_Real uz_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_look_at_set(target_space_, x_, y_, z_, up_space_, ux_, uy_, uz_));
      }

      virtual void mesh_add(Evas_3D_Mesh * mesh_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_mesh_add(mesh_));
      }

      virtual void mesh_del(Evas_3D_Mesh * mesh_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_mesh_del(mesh_));
      }

      virtual ::efl::eina::crange_list< Evas_3D_Mesh * > mesh_list_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_mesh_list_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< Evas_3D_Mesh * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual void bounding_box_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * x2_, Evas_Real * y2_, Evas_Real * z2_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_bounding_box_get(x_, y_, z_, x2_, y2_, z2_));
      }

      virtual void bounding_sphere_get(Evas_Real * x_, Evas_Real * y_, Evas_Real * z_, Evas_Real * r_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_bounding_sphere_get(x_, y_, z_, r_));
      }

      virtual bool position_inherit_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_position_inherit_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void position_inherit_set(bool inherit_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_position_inherit_set(::efl::eolian::to_c(inherit_)));
      }

      virtual bool orientation_inherit_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_orientation_inherit_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void orientation_inherit_set(bool inherit_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_orientation_inherit_set(::efl::eolian::to_c(inherit_)));
      }

      virtual bool scale_inherit_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_scale_inherit_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void scale_inherit_set(bool inherit_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_scale_inherit_set(::efl::eolian::to_c(inherit_)));
      }

      virtual Evas_3D_Camera * camera_get()
      {
         Evas_3D_Camera * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_camera_get());
            return _tmp_ret;
      }

      virtual void camera_set(Evas_3D_Camera * camera_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_camera_set(camera_));
      }

      virtual Evas_3D_Light * light_get()
      {
         Evas_3D_Light * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_light_get());
            return _tmp_ret;
      }

      virtual void light_set(Evas_3D_Light * light_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_light_set(light_));
      }

      virtual int mesh_frame_get(Evas_3D_Mesh * mesh_)
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_mesh_frame_get(mesh_));
            return _tmp_ret;
      }

      virtual void mesh_frame_set(Evas_3D_Mesh * mesh_, int frame_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_mesh_frame_set(mesh_, frame_));
      }

      virtual ::efl::eo::concrete billboard_target_get()
      {
         Eo * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_node_billboard_target_get());
            return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void billboard_target_set(::efl::eo::concrete target_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_node_billboard_target_set(::efl::eolian::to_c(target_)));
      }

   };
};


#ifdef EVAS_3D_NODE_PROTECTED
template<>
struct operation_description_class_size< ::evas_3d_node >
{
   static constexpr int value = 32 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#else
template<>
struct operation_description_class_size< ::evas_3d_node >
{
   static constexpr int value = 32 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#endif

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_node>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_node_type_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_node_type_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_node_member_add_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_node_member_add);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_node_member_del_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_node_member_del);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_node_parent_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_node_parent_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_node_member_list_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_node_member_list_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_node_position_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_node_position_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_node_orientation_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_node_orientation_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_node_orientation_angle_axis_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_node_orientation_angle_axis_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_node_scale_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_node_scale_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_node_position_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_node_position_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_node_orientation_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_node_orientation_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_node_scale_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_node_scale_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_node_look_at_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_node_look_at_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_node_mesh_add_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_node_mesh_add);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_node_mesh_del_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_node_mesh_del);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_evas_3d_node_mesh_list_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::evas_3d_node_mesh_list_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_evas_3d_node_bounding_box_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::evas_3d_node_bounding_box_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_evas_3d_node_bounding_sphere_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::evas_3d_node_bounding_sphere_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_evas_3d_node_position_inherit_get_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::evas_3d_node_position_inherit_get);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_evas_3d_node_position_inherit_set_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::evas_3d_node_position_inherit_set);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_evas_3d_node_orientation_inherit_get_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::evas_3d_node_orientation_inherit_get);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_evas_3d_node_orientation_inherit_set_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::evas_3d_node_orientation_inherit_set);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_evas_3d_node_scale_inherit_get_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::evas_3d_node_scale_inherit_get);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_evas_3d_node_scale_inherit_set_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::evas_3d_node_scale_inherit_set);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_evas_3d_node_camera_get_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::evas_3d_node_camera_get);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_evas_3d_node_camera_set_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::evas_3d_node_camera_set);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_evas_3d_node_light_get_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::evas_3d_node_light_get);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_evas_3d_node_light_set_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::evas_3d_node_light_set);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_evas_3d_node_mesh_frame_get_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::evas_3d_node_mesh_frame_get);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::_evas_3d_node_mesh_frame_set_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::evas_3d_node_mesh_frame_set);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::_evas_3d_node_billboard_target_get_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::evas_3d_node_billboard_target_get);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::_evas_3d_node_billboard_target_set_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::evas_3d_node_billboard_target_set);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[operation_description_class_size< ::evas_3d_node >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[operation_description_class_size< ::evas_3d_node >::value + operation_description_class_size<::evas_3d_object>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::evas_3d_node>)
{
   return (EVAS_3D_NODE_CLASS);
}

} } }

/// @endcond

